#############################################
##### EXERCICIO 5 - CRIACAO DE GRAFICOS #####
#############################################

###############################################
### 5.1 EDITANDO ALGUNS PARAMETROS GRAFICOS ###
###############################################
setwd("C:/Users/renat/OneDrive/Documentos/Estudos/UNIFESP/Mestrado/Disciplinas/Using_R/Aula_20-05/Exercicios")
saligna <- read.csv("esaligna.csv", sep=",", dec=".", header=T,as.is=F)
head(saligna)

plot(saligna$ht~saligna$dap)
par(pch=16)
par(cex.lab=1.5,cex.axis=1.7)
par(tcl=0.3, las=1, bty="l")
plot(saligna$ht~saligna$dap, xlab="Dimetro  altura do peito (cm)", ylab="Altura (m)", main="Eucalypthus saligna", cex.main=1.8, cex=1.4, col="red")

png("saligna.png")

###############################################
########## 5.2 DOIS GRAFICOS JUNTOS ###########
###############################################
par(mfrow=c(1,2))
par(cex.lab=1.5,cex.axis=1.7)
par(tcl=0.3, las=1, bty="l")
boxplot(saligna$dap~saligna$talhao, xlab="Talhão", ylab="Diâmetro à altura do peito (cm)", main="Eucalypthus saligna", cex.main=1.6, cex=1.4, col="red")
text(x=1,y=23, "a")

(med <- tapply(saligna$dap,saligna$talhao,mean))
(dp <- tapply(saligna$dap,saligna$talhao,sd))
tal <- c(16,17,18,22,23,32)

(dp.mais <- med+dp)
(dp.menos <- med-dp)

par(cex.lab=1.5,cex.axis=1.7)
par(tcl=0.3, las=1, bty="l")
plot(x=NULL,y=NULL, type="n",xlim=c(16,32), ylim=c(6,21), xlab="Talhão", ylab="Dimetro  altura do peito (cm)", main="Eucalypthus saligna", cex.main=1.6)

points (x=16,y=14.10012, pch="-", cex=2)
points (x=16,y=6.633214, pch="-", cex=2)
segments(x=16, y0=6.633214, x1=16, y1=14.10012)
points (x=16,y=10.36667, pch=19, col="red", cex=1.4)

points (x=17,y=19.00967, pch="-", cex=2)
points (x=17,y=6.961754, pch="-", cex=2)
segments(x=17, y0=6.961754, x1=17, y1=19.00967)
points (x=17,y=12.98571, pch=19, col="red", cex=1.4)

points (x=18,y=15.89987, pch="-", cex=2)
points (x=18,y=7.366797, pch="-", cex=2)
segments(x=18, y0=7.366797, x1=18, y1=15.89987)
points (x=18,y=11.63333, pch=19, col="red", cex=1.4)

points (x=22,y=20.86379, pch="-", cex=2)
points (x=22,y=9.896206, pch="-", cex=2)
segments(x=22, y0=9.896206, x1=22, y1=20.86379)
points (x=22,y=15.38000, pch=19, col="red", cex=1.4)

points (x=23,y=18.74182, pch="-", cex=2)
points (x=23,y=8.433185, pch="-", cex=2)
segments(x=23, y0=8.433185, x1=23, y1=18.74182)
points (x=23,y=13.5875, pch=19, col="red", cex=1.4)

points (x=32,y=19.43550, pch="-", cex=2)
points (x=32,y=6.864501, pch="-", cex=2)
segments(x=32, y0=6.864501, x1=32, y1=19.43550)
points (x=32,y=13.15000, pch=19, col="red", cex=1.4)

text(x=17,y=21, "b")

#####################################
##### 5.3 ADIVINHANDO O CODIGO ######
#####################################
dados<-read.csv("exercicio3.csv", header=T, sep=",", dec=".")
head(dados)

par(mfrow=c(1,2))
par(cex.lab=1.4,cex.axis=1.4)
par(tcl=0.3, las=1, bty="l")
plot(dados$y1~dados$x1, pch=17, ylab="Euclidean distances", xlab="Log(Patch size)(ha)", cex=1.4, family="serif", xlim=c(0.5,2.2), ylim=c(0,3.0))

mod <- lm(dados$y1~dados$x1)

abline(mod, lwd=4)
text(x=2.2,y=3,"a")
### Boxplot
par(cex.lab=1.5,cex.axis=0.7)
par(tcl=0.3, las=1, bty="l")
boxplot(dados$x2~dados$y2, names=c("Small", "Medium \n Edge", "Medium\n Interior", "Large \n Edge", "Large \n Interior", "Control"), family="serif", ylim=c(0,3), outline=F)

text(x=c(1,2,2.9,3.1,4,4.8,4.95,5.1),y=3.0,"*")
text(x=6,y=3,"b")

