
# 107.1b #
babies <- read.csv("babies.csv",header=T, sep="")
str(babies)
babies <- babies[babies$gestation!=999,] 
babies$bwt <- babies$bwt/35.274 
mod1 <- lm(babies$bwt~babies$gestation)
summary(mod1)
mod1$df.residual

x <- seq(min(babies$gestation), max(babies$gestation), length.out= 100)
s2 <- var(babies$bwt, na.rm = T)
n <- 1/length(babies$gestation)
xx2 <- (x-mean(babies$gestation))^2
ssx <- sum(xx2)

(sey <- sqrt(s2*(n + xx2/ssx)))
(t <- qt(0.975, mod1$df.residual))
(est <- coef(mod1)[1] + coef(mod1)[2]*x)
(sup <- est+(t*sey))
(inf <- est-(t*sey))

plot(babies$bwt~babies$gestation, xlab= "Tempo de gestao (dias)", ylab = "Peso do beb (Kg)", las = 1)
abline(mod1, lwd= 3,col="red")
lines(x=x, y=sup, col="green", lwd= 2)
lines(x=x, y=inf, col="green", lwd= 2)

#107.2b #
init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)
mod1 <- lm(h.d~init.h)
mod2 <- lm(h.d~init.h+I(init.h^2))
mod3 <- lm(h.d~init.h+I(init.h^2)+I(init.h^3))
anova(mod1,mod2)
anova(mod2,mod3)
plot(h.d~init.h)
abline(mod1)
cf.m2 <- coef(mod2)
cf.m3 <- coef(mod3)
curve(cf.m2[1]+cf.m2[2]*x+cf.m2[3]*x^2, add=T, lty=2)
curve(cf.m3[1]+cf.m3[2]*x+cf.m3[3]*x^2 +cf.m3[4]*x^3, add=T, lwd=2, lty=1, col= "green")

#O modelo com polinmio de terceiro grau  o que melhor se ajusta aos dados

# 107.3b #
babies <- read.csv("babies.csv", sep="")
babies <- babies[babies$bwt!=999,] #Retirando os 999
babies <- babies[babies$gestation!=999,] #Retirando os 999
babies <- babies[babies$parity!=9,] #Retirando os 9
babies <- babies[babies$age!=99,] #Retirando os 99
babies <- babies[babies$height!=99,] #Retirando os 99
babies <- babies[babies$weight!=999,] #Retirando os 999
babies <- babies[babies$smoke!=9,] #Retirando os 9
babies$bwt <- babies$bwt/35.274 #Convertendo o peso para Kg

#MODELOS
mod0 <- lm(bwt ~ gestation*parity*age*height*weight*smoke, data=babies)
summary(mod0)

mod1 <- update(mod0,.~. -gestation:parity:age:height:weight:smoke, data=babies)
summary(mod1)
anova(mod0,mod1)

mod2 <- update(mod1,.~. -gestation:parity:height:weight:smoke, data=babies)
summary(mod2)
anova(mod1,mod2)

mod3 <- update(mod2,.~. -gestation:parity:age:height:weight, data=babies)
summary(mod3)
anova(mod2,mod3)

mod4 <- update(mod3,.~. -gestation:age:height:weight:smoke, data=babies)
summary(mod4)
anova(mod3,mod4)

mod5 <- update(mod4,.~. -parity:age:height:weight:smoke, data=babies)
summary(mod5)
anova(mod4,mod5)

mod6 <- update(mod5,.~. -gestation:height:weight:smoke, data=babies)
summary(mod6)
anova(mod5,mod6)

mod7 <- update(mod6,.~. -gestation:age:weight:smoke, data=babies)
summary(mod7)
anova(mod6,mod7)

mod8 <- update(mod7,.~. -parity:height:weight:smoke, data=babies)
summary(mod8)
anova(mod7,mod8)

mod9 <- update(mod8,.~. -age:height:weight:smoke, data=babies)
summary(mod9)
anova(mod8,mod9)

mod10 <- update(mod9,.~. -gestation:age:height:smoke, data=babies)
summary(mod10)
anova(mod9,mod10)

mod11 <- update(mod10,.~. -gestation:parity:age:smoke, data=babies)
summary(mod11)
anova(mod10,mod11)

mod12 <- update(mod1,.~. -parity:age:height:smoke, data=babies)
summary(mod12)
anova(mod11,mod12)

mod13 <- update(mod12,.~. -gestation:parity:age:weight:smoke, data=babies)
summary(mod13)
anova(mod12,mod13)

mod14 <- update(mod13,.~. -gestation:parity:age:height:weight, data=babies)
summary(mod14)
anova(mod13,mod14)

mod15 <- update(mod14,.~. -gestation:parity:weight:smoke, data=babies)
summary(mod15)
anova(mod14,mod15)

mod16 <- update(mod15,.~. -gestation:parity:height:weight:smoke, data=babies)
summary(mod16)
anova(mod15,mod16)

mod17 <- update(mod16,.~. -gestation:parity:height:smoke, data=babies)
summary(mod17)
anova(mod16,mod17)

mod18 <- update(mod17,.~. -parity:age:weight:smoke, data=babies)
summary(mod18)
anova(mod17,mod18)

mod19 <- update(mod18,.~. -gestation:parity:age:height:smoke, data=babies)
summary(mod19)
anova(mod18,mod19)

mod20 <- update(mod19,.~. -parity:age:height:weight:smoke, data=babies)
summary(mod20)
anova(mod19,mod20)

mod21 <- update(mod20,.~. -gestation:age:height:weight, data=babies)
summary(mod21)
anova(mod20,mod21)

mod22 <- update(mod21,.~. -parity:height:weight:smoke, data=babies)
summary(mod22)
anova(mod21,mod22)

mod23 <- update(mod22,.~. -gestation:height:weight:smoke, data=babies)
summary(mod23)
anova(mod22,mod23)

mod24 <- update(mod23,.~. -age:height:weight:smoke, data=babies)
summary(mod24)
anova(mod23,mod24)

mod25 <- update(mod24,.~. -gestation:age:height:weight:smoke, data=babies)
summary(mod25)
anova(mod24,mod25)

mod26 <- update(mod25,.~. -gestation:age:weight:smoke, data=babies)
summary(mod26)
anova(mod25,mod26)

mod27<- update(mod26,.~. -gestation:parity:age:smoke, data=babies)
summary(mod27)
anova(mod26,mod27)

mod28 <- update(mod27,.~. -gestation:age:height:smoke, data=babies)
summary(mod28)
anova(mod27,mod28)

mod29 <- update(mod28,.~. -gestation:parity:age:weight, data=babies)
summary(mod29)
anova(mod28,mod29)

mod30 <- update(mod29,.~. -gestation:parity:height:weight, data=babies)
summary(mod30)
anova(mod29,mod30)

mod31 <- update(mod30,.~. -gestation:weight:smoke, data=babies)
summary(mod31)
anova(mod30,mod31)

mod32 <- update(mod31,.~. -gestation:parity:age:height, data=babies)
summary(mod32)
anova(mod31,mod32)

mod33 <- update(mod32,.~. -parity:age:height:smoke, data=babies)
summary(mod33)
anova(mod32,mod33)

mod34 <- update(mod33,.~. -parity:height:smoke, data=babies)
summary(mod34)
anova(mod33,mod34)

mod35 <- update(mod34,.~. -gestation:age:weight, data=babies)
summary(mod35)
anova(mod34,mod35)

mod36 <- update(mod35,.~. -age:weight:smoke, data=babies)
summary(mod36)
anova(mod35,mod36)

mod37 <- update(mod36,.~. -gestation:parity:smoke, data=babies)
summary(mod37)
anova(mod36,mod37)

mod38 <- update(mod37,.~. -height:weight:smoke, data=babies)
summary(mod38)
anova(mod37,mod38)

mod39 <- update(mod38,.~. -gestation:parity:weight, data=babies)
summary(mod39)
anova(mod38,mod39)

mod40 <- update(mod39,.~. -parity:age:smoke, data=babies)
summary(mod40)
anova(mod39,mod40)

mod41 <- update(mod40,.~. -gestation:parity:age, data=babies)
summary(mod41)
anova(mod40,mod41)

mod42 <- update(mod41,.~. -age:height:weight, data=babies)
summary(mod42)
anova(mod41,mod42)

mod43 <- update(mod42,.~. -gestation:height:weight, data=babies)
summary(mod43)
anova(mod42,mod43)

mod44 <- update(mod43,.~. -gestation:parity:height, data=babies)
summary(mod44)
anova(mod43,mod44)

mod45 <- update(mod44,.~. -age:height:smoke, data=babies)
summary(mod45)
anova(mod44,mod45)

mod46 <- update(mod45,.~. -gestation:age:smoke, data=babies)
summary(mod46)
anova(mod45,mod46)

mod47 <- update(mod46,.~. -height:weight, data=babies)
summary(mod47)
anova(mod46,mod47)

mod48 <- update(mod47,.~. -weight:smoke, data=babies)
summary(mod48)
anova(mod47,mod48)

mod49 <- update(mod48,.~. -age:weight, data=babies)
summary(mod49)
anova(mod48,mod49)

mod50 <- update(mod49,.~. -gestation:age:height, data=babies)
summary(mod50)
anova(mod49,mod50)

mod51 <- update(mod50,.~. -parity:weight:smoke, data=babies)
summary(mod51)
anova(mod50,mod51)

mod52 <- update(mod51,.~. -parity:age:height:weight, data=babies)
summary(mod52)
anova(mod51,mod52)

mod53 <- update(mod52,.~. -parity:age:height, data=babies)
summary(mod53)
anova(mod52,mod53)

mod54 <- update(mod53,.~. -parity:height:weight, data=babies)
summary(mod54)
anova(mod53,mod54)

mod55 <- update(mod54,.~. -parity:age:weight, data=babies)
summary(mod55)
anova(mod54,mod55)

mod56 <- update(mod55,.~. -gestation:height, data=babies)
summary(mod56)
anova(mod55,mod56)

mod57 <- update(mod56,.~. -age:height, data=babies)
summary(mod57)
anova(mod56,mod57)

mod58<- update(mod57,.~. -parity:weight, data=babies)
summary(mod58)
anova(mod57,mod58)

mod59 <- update(mod58,.~. -parity:smoke, data=babies)
summary(mod59)
anova(mod58,mod59)


mod60 <- update(mod59,.~. -parity:age, data=babies)
summary(mod60)
anova(mod59,mod60)

mod61 <- update(mod60,.~. -age:smoke, data=babies)
summary(mod61)
anova(mod60,mod61)

mod62 <- update(mod61,.~. -gestation:parity, data=babies)
summary(mod62)
anova(mod61,mod62)

mod63 <- update(mod62,.~. -parity:height, data=babies)
summary(mod63)
anova(mod62,mod63)

mod64<- update(mod63,.~. -gestation:height:smoke, data=babies)
summary(mod64)
anova(mod63,mod64)



#MELHOR MODELO : mod64


#MODELO 64:
# GESTATION + PARITY + AGE + HEIGHT + WEIGHT + SMOKE + GESTATION: AGE +
# GESTATION: WEIGHT + GESTATION: SMOKE + HEIGHT: SMOKE + GESTATION:HEIGHT:SMOKE

