##Exerccios 4 - Anlises Exploratrias

####4.2 - Cervejas
#Cria o set de dados "Cervejas"
cervejas <-c("chope","lata","garrafa","chope","garrafa", "garrafa","lata","lata","nenhuma","lata","garrafa","garrafa", "garrafa","lata","lata","lata","garrafa","lata","chope","nenhuma", "garrafa","garrafa","garrafa","chope","garrafa","garrafa","chope","garrafa","lata","lata")
tabela.cervejas <- as.matrix(table(cervejas))

#Grfico de barras
barplot(table(cervejas))

#Dotchart
dotchart(table(cervejas))

#O grfico com a menor relao dado/tinta  o dotchart, que entrega mais informaes com menos 'poluio'.


####4.3 - Caixetais
#Abre os dados e gera o DAP
caixeta <- read.csv("caixeta.csv", header=T, sep=",")
head(caixeta)
dap <- caixeta$cap/pi
caixeta$dap <- dap
head(caixeta)

#Gera um nico layout com os 4 histogramas
par(mfrow=c(2,2))


#Faz o histograma do DAP dos fustes
hist(caixeta$dap)

#Histograma para Chauas
chauas.h <- caixeta[caixeta$local == "chauas",]
head(chauas.h)

#Histograma para Jureia
jureia.h <- caixeta[caixeta$local == "jureia",]
head(jureia.h)
hist(jureia.h$h)

#Histograma para Retiro
retiro.h <- caixeta[caixeta$local == "retiro",]
head(retiro.h)
hist(retiro.h$h)

#H diferenas entre as estruturas (distribuio de tamanhos) dos caixetais?
##Sim, h diferena. Em Chauas h maior frequncia das rvores mais baixas do que na Jureia e em Retiro.

####4.4 Eucaliptos
#Abre os dados
e.grandis <- read.csv("egrandis.csv", header=T, sep=";")
head(e.grandis)

#Gera o boxplot DAP por regio
par(mfrow=c(1,1))
boxplot(e.grandis$dap ~ e.grandis$regiao)

#Gera o grfico quantil quantil
qqnorm(e.grandis$ht)
qqline(e.grandis$ht)

####4.5 Mais Caixetais

#Restringe dados para Caixeta
dados.caixeta <- caixeta[caixeta$especie == "Tabebuia cassinoides",]

#Restringe para Chauas
dados.caixeta.chauas <- dados.caixeta[dados.caixeta$local == "chauas",]

#Restringe para Retiro
dados.caixeta.retiro <- dados.caixeta[dados.caixeta$local == "retiro",]

#Restringe para Jureia
dados.caixeta.jureia <- dados.caixeta[dados.caixeta$local == "jureia",]

#Calcula DAP e altura total para Chauas

area.basal.chauas <- pi*(dados.caixeta.chauas$dap/2)^2
dados.caixeta.chauas$area.basal <- area.basal.chauas
area.total.chauas <- tapply(X=dados.caixeta.chauas$area.basal, INDEX=dados.caixeta.chauas$arvore, FUN=sum)
dap.total.chauas <- sqrt(area.total.chauas/pi)*2
altura.total.chauas <- tapply(X=dados.caixeta.chauas$h, INDEX=dados.caixeta.chauas$arvore, FUN=mean)

#Calcula DAP e altura total para Retiro

area.basal.retiro <- pi*(dados.caixeta.retiro$dap/2)^2
dados.caixeta.retiro$area.basal <- area.basal.retiro
area.total.retiro <- tapply(X=dados.caixeta.retiro$area.basal, INDEX=dados.caixeta.retiro$arvore, FUN=sum)
dap.total.retiro <- sqrt(area.total.retiro/pi)*2
altura.total.retiro <- tapply(X=dados.caixeta.retiro$h, INDEX=dados.caixeta.retiro$arvore, FUN=mean)

#Calcula DAP e altura total para Jureia

area.basal.jureia <- pi*(dados.caixeta.jureia$dap/2)^2
dados.caixeta.jureia$area.basal <- area.basal.jureia
area.total.jureia <- tapply(X=dados.caixeta.jureia$area.basal, INDEX=dados.caixeta.jureia$arvore, FUN=sum)
dap.total.jureia <- sqrt(area.total.jureia/pi)*2
altura.total.jureia <- tapply(X=dados.caixeta.jureia$h, INDEX=dados.caixeta.jureia$arvore, FUN=mean)

par(mfrow=c(2,2))

plot(dap.total.chauas ~ altura.total.chauas)
plot(dap.total.retiro ~ altura.total.retiro)
plot(dap.total.jureia ~ altura.total.jureia)

par(mfrow=c(2,2))

scatter.smooth(dap.total.chauas ~ altura.total.chauas)
scatter.smooth(dap.total.retiro ~ altura.total.retiro)
scatter.smooth(dap.total.jureia ~ altura.total.jureia)

# Preparando dados para pacote lattice

length(dap.total.chauas)
length(dap.total.jureia)
length(dap.total.retiro)

locais <- c(rep("chauas", 191), rep("jureia", 86), rep("retiro", 132))
dap.todos <- c(dap.total.chauas, dap.total.jureia, dap.total.retiro)
altura.todos <- c(altura.total.chauas, altura.total.jureia, altura.total.retiro)

caixeta.daps <- data.frame(locais, dap.todos, altura.todos)

# Pacote lattice
library(lattice)
xyplot(dap.todos~altura.todos|locais, data= caixeta.daps)