####Exerccios 5 - Criao de Grficos

##Exerccio 5.1
#Carrega os dados de e.saligna
saligna <- read.csv("esaligna.csv", header=T, sep=",")
#Verifica se os dados foram carregados corretamente
head(saligna)
#Abre o arquivo PNG
png(filename = "saligna.png",
    width = 480, height = 480, units = "px", pointsize = 12,
    bg = "white")
#Determina os parmetros do grfico
par(cex.lab=1.7, cex.axis=1.5, las=1, tcl=0.3, bty="l", cex.main=1.8)
#Plota o grfico
plot(dap[saligna$arvore] ~ ht[saligna$arvore], data=saligna, cex=1.4, pch=16, col="red", xlab="Dimetro  altura do peito (cm)", ylab="Altura (m)")
#Adiciona o ttulo ao grfico
title("Eucalypthus saligna")
#Fecha o arquivo PNG e salva
dev.off()

## Exerccio 5.2
#Cria um espao para grfico com 2 colunas
par(mfrow=c(1,2))
#Estabelece os parmetros do grfico
par(las=1, tcl=0.3, bty="l")
#Cria o boxplot
boxplot(dap ~talhao, data=saligna, xlab="Talho", ylab="DAP")
mtext(text="a", line="1", adj=0)
#Obtem os dados para fazer o grfico de mdia (manual)
media.talhao <- tapply(X=saligna$dap, INDEX=saligna$talhao, FUN=mean)
sd.talhao <- tapply(X=saligna$dap, INDEX=saligna$talhao, FUN=sd)
media.sd1 <- media.talhao - sd.talhao
media.sd2 <- media.talhao + sd.talhao
#Plota os dados de mdia e desvio padro
plot(media.talhao, ylim=c(0,25), pch=19, xlab="Mdia do DAP", ylab="Talho", xaxt="n" )
segments(x=seq(1:6), y0=media.sd1, x1=(1:6), y1=media.sd2)
points (x=seq(1:6),y=media.sd1, pch="-", cex=1.5)
points (x=seq(1:6),y=media.sd2, pch="-", cex=1.5)
axis(1, at=seq(1:6), labels=c("16", "17", "18", "22", "23", "32"))
mtext(text="b", line="1", adj=0)

## Exerccio 5.3
#L os dados do exerccio
exercicio3 <- read.csv("exercicio3.csv", header=T, sep=",")
head(exercicio3)
#Divide a rea do grfico em duas colunas e estabelece parmetros bsicos
par(mfrow=c(1,2), las=1, tcl=0.3, bty="l", family="serif")
#Plota o primeiro grfico
par(las=1, tcl=0.3, bty="l", family="serif", cex.lab=1, cex=1.5, cex.axis=0.7, mar=c(5, 4, 4, 1))
plot(x2 ~x1, data=exercicio3, pch=17, ylim=c(0.0,3.0), xlim=c(0.5, 2.0), ylab="Euclidean distances", xlab="Log(Patch size)(ha)")
#Faz o modelo linear e plota a linha no grfico
modelo <- lm(x2~x1, data=exercicio3)
abline(modelo, lwd=2)
#Coloca identificao do grfico (a)
text(x=2.0,y=3.0,"a", cex=1)
#Plota o segundo grfico
par(las=1, tcl=0.3, bty="l", family="serif", mar=c(5, 2, 4, 1))
boxplot(x2 ~y2, data=exercicio3, outline=F, xaxt="n", ylim=c(0,3.0))
#Altera nomes do eixo x
axis(1, at=seq(1:6), labels=c("Small", "Medium \n Edge", "Medium \n Inferior", "Large \n Edge", "Large \n Inferior", "Control"))
#Adiciona os identificadores de diferena estatstica
text(x=seq(1:6),y=3.0,c("*","*","**","*","***",""), cex=1)
#Coloca identificao do grfico (b)
text(x=6.5,y=3.0,"b", cex=1)


