###7b. Exercícios de Regressão Múltipla
##Uma estimativa da incerteza na previsão do modelo
#Lê os dados da planilha babies.csv
bebes <- read.table("babies.txt", header=T, sep = " ")
head(bebes)
str(bebes)
bebes
summary(bebes)
#Retira os dados faltantes
bebes <- bebes[bebes$bwt != "999",]
bebes <- bebes[bebes$gestation != "999",]
bebes <- bebes[bebes$parity != "9",]
bebes <- bebes[bebes$age != "99",]
bebes <- bebes[bebes$height != "99",]
bebes <- bebes[bebes$weight != "999",]
bebes <- bebes[bebes$smoke != "9",]
summary(bebes)
#Faz o modelo para peso do bebê em função do tempo de gestação
lm.bebes <- lm(bwt ~ gestation, data=bebes)
summary(lm.bebes)
anova(lm.bebes)
#Grava os coeficientes do modelo
coef.lmbebes <- coef(lm.bebes)
coef.lmbebes
#Fazendo a estimativa de incerteza
ssx.bebe <- sum((bebes$gestation-mean(bebes$gestation))^2)
xmx <- seq(min(bebes$gestation), max(bebes$gestation), length.out = 100)
xmx.mean <- xmx-mean(bebes$gestation)
xmxsq <- xmx.mean^2
var.y <- var(bebes$bwt)
erro.padrao <- sqrt(var.y*((1/length(bebes$gestation))+(xmxsq/ssx.bebe)))
#Obtém o valor de t
t.student <- qt(0.025, length(bebes$gestation-2))
t.student
#Multiplica o erro pelo t
erro.positivo <- erro.padrao*abs(t.student)
erro.negativo <- erro.padrao*t.student
#Estabelece os limites superiores e inferiores
upper <- coef.lmbebes[1]+(coef.lmbebes[2]*xmx)+erro.positivo
lower <- coef.lmbebes[1]+(coef.lmbebes[2]*xmx)+erro.negativo
#Fazendo o gráfico
par(mfrow=c(1,1), mar=c(4,4,2,2), bty="n")
plot(bwt ~ gestation, data=bebes, pch=16, col= rgb(0,0,0.6,0.3), xlab="Gestation duration", ylab="Baby weigth in oz")
#Adiciona o polígono
polygon(c(rev(xmx), xmx), c(rev(upper), lower), col = rgb(0,0,0,0.2), border = NA)
#Adiciona a linha do modelo
abline(lm.bebes, col= rgb(0.2,0.6,0.8,1), lwd=2)
###
####Galileu
#Estabelece os dados do exercício
init.h = c(600, 700, 800, 950, 1100, 1300, 1500)
h.d = c(253, 337, 395, 451, 495, 534, 573)
#Faz os modelos
lmg.01 <- lm(h.d ~ init.h)
lmg.02 <- lm(h.d ~ init.h + I(init.h^2))
lmg.03 <- lm(h.d ~ init.h + I(init.h^2) + I(init.h^3))
#Compara o modelo de terceira e segunda ordem
anova(lmg.02, lmg.03)
# O p do F é significativo, ou seja, o polinômio de terceira grau é melhor. Retêm-se a de maior complexidade.
###
####Massa de Recém-Nascidos
str(bebes)
#Transforma "parity" e "smoke" em fatores
bebes$parity <- as.factor(bebes$parity)
bebes$smoke <- as.factor(bebes$smoke)
str(bebes)
#Faz um modelo com todas as interações possíveis e que podem ter significado para obter o modelo
#de previsão do peso do bebê ao nascer. Após discussão com os monitores
#ficou claro que seria impossível fazer um modelo com todas as variáveis e interações entre elas.
lm.bebes.todas <- lm(bwt ~ gestation + age + weight + smoke 
                     + gestation:age + gestation:weight
                     + age:weight + gestation:smoke + age:smoke + weight:smoke
                     + gestation:age:weight + gestation:age:smoke
                     + gestation:weight:smoke + age:weight:smoke
                     + gestation:age:weight:smoke, data=bebes)
#Retorna o summary do modelo
summary(lm.bebes.todas)
anova(lm.bebes.todas)
#Sem interação gestation:age:weight:smoke
lm.bebes.01 <- lm(bwt ~ gestation + age + weight + smoke 
                  + gestation:age + gestation:weight
                  + age:weight + gestation:smoke + age:smoke + weight:smoke
                  + gestation:age:weight + gestation:age:smoke
                  + gestation:weight:smoke + age:weight:smoke
                  , data=bebes)
anova(lm.bebes.todas, lm.bebes.01)
summary(lm.bebes.01)
#Sem interação gestation:age:weight
lm.bebes.02 <- lm(bwt ~ gestation + age + weight + smoke 
                  + gestation:age + gestation:weight
                  + age:weight + gestation:smoke + age:smoke + weight:smoke
                  + gestation:age:smoke
                  + gestation:weight:smoke + age:weight:smoke
                  , data=bebes)
anova(lm.bebes.01, lm.bebes.02)
summary(lm.bebes.02)
#Sem interação gestation:age:smoke
lm.bebes.03 <- lm(bwt ~ gestation + age + weight + smoke 
                  + gestation:age + gestation:weight
                  + age:weight + gestation:smoke + age:smoke + weight:smoke
                  + gestation:age:weight
                  + gestation:weight:smoke + age:weight:smoke
                  , data=bebes)
anova(lm.bebes.01, lm.bebes.03)
summary(lm.bebes.03)
#Sem interação gestation:weight:smoke
lm.bebes.04 <- lm(bwt ~ gestation + age + weight + smoke 
                  + gestation:age + gestation:weight
                  + age:weight + gestation:smoke + age:smoke + weight:smoke
                  + gestation:age:weight + gestation:age:smoke
                  + age:weight:smoke
                  , data=bebes)
anova(lm.bebes.01, lm.bebes.04)
summary(lm.bebes.04)
#Sem interação age:weight:smoke
lm.bebes.05 <- lm(bwt ~ gestation + age + weight + smoke 
                  + gestation:age + gestation:weight
                  + age:weight + gestation:smoke + age:smoke + weight:smoke
                  + gestation:age:weight + gestation:age:smoke
                  + gestation:weight:smoke
                  , data=bebes)
anova(lm.bebes.01, lm.bebes.05)
##Em todos os casos, as interações de três fatores não foram significativas para o modelo. Retirando todas e comparando:
lm.bebes.06 <- lm(bwt ~ gestation + age + weight + smoke 
                  + gestation:age + gestation:weight
                  + age:weight + gestation:smoke + age:smoke + weight:smoke
                  , data=bebes)
anova(lm.bebes.01, lm.bebes.06)
summary(lm.bebes.06)
#De fato, interações de três fatores não foram significativas.
#Prosseguindo para as de duas interações.
#Sem interação weight:smoke
lm.bebes.07 <- lm(bwt ~ gestation + age + weight + smoke 
                  + gestation:age + gestation:weight
                  + age:weight + gestation:smoke + age:smoke
                  , data=bebes)
anova(lm.bebes.06, lm.bebes.07)
#Sem interação age:smoke
lm.bebes.08 <- lm(bwt ~ gestation + age + weight + smoke 
                  + gestation:age + gestation:weight
                  + age:weight + gestation:smoke + weight:smoke
                  , data=bebes)
anova(lm.bebes.06, lm.bebes.08)

#Sem interação gestation:smoke
lm.bebes.09 <- lm(bwt ~ gestation + age + weight + smoke 
                  + gestation:age + gestation:weight
                  + age:weight + age:smoke + weight:smoke
                  , data=bebes)
anova(lm.bebes.06, lm.bebes.09)
#### gestation:smoke seria significativo. Avaliando outros.

#Sem interação age:weight
lm.bebes.10 <- lm(bwt ~ gestation + age + weight + smoke 
                  + gestation:age + gestation:weight
                  + gestation:smoke + age:smoke + weight:smoke
                  , data=bebes)
anova(lm.bebes.06, lm.bebes.10)

#Sem interação gestation:weight
lm.bebes.11 <- lm(bwt ~ gestation + age + weight + smoke 
                  + gestation:age
                  + age:weight + gestation:smoke + age:smoke + weight:smoke
                  , data=bebes)
anova(lm.bebes.06, lm.bebes.11)

#Sem interação gestation:age
lm.bebes.12 <- lm(bwt ~ gestation + age + weight + smoke 
                  + gestation:weight
                  + age:weight + gestation:smoke + weight:smoke
                  , data=bebes)
anova(lm.bebes.06, lm.bebes.12)
###Também demonstrou ser significativo
#Decide-se manter apenas as interações gestation:age e gestation:smoke
lm.bebes.13 <- lm(bwt ~ gestation + age + weight + smoke 
                  + gestation:age
                  + gestation:smoke
                  , data=bebes)
#O modelo lm.bebes.13 é o melhor modelo de previsão da massa de bebês ao nascer.
