## Reamostragem e simulação
# Exercício 1
#Lendo os dados da distribuição de palmitos em uma parcela de 10,24h de floresta
eutad <- read.table("palmadulto.txt", header=T, sep="\t")
#Checando estrutura dos dados
head(eutad)
str(eutad)
n.total <- length(eutad$gx)
#Cria o objeto para guardar as distâncias entre cada indivíduo
dist <- matrix(NA, ncol=102, nrow=102)
#Calcula a distância observada entre cada indivíduo
for (i in 1:101) {
  for (j in (i+1):102) {
    difx2=(eutad$gx[i]-eutad$gx[j])^2
    dify2=(eutad$gy[i]-eutad$gy[j])^2
    dist[i,j]<-sqrt(difx2 + dify2)
    dist[j,i]<-sqrt(difx2 + dify2)
  }
}
#Verifica os dados
head(dist)
str(dist)
#Calcula a distância média do vizinho mais próximo (nn) e a média de nn (mnn)
nn <- apply(dist, 1, min, na.rm=TRUE)
mnn <- mean(nn)
nn
mnn
#######
#1.5. Crie um vetor resultado, com 1000 NA's, para guardar os valores de cada simulação.
nsim <- 1000
resultado <- rep(NA,nsim)
#1.6. Guarde o valor observado na primeira posição de resultado;
resultado[1] <- mnn
head(resultado)
#1.7. Crie um ciclo com contador (k) que vai de 2 a 1000;
for (k in 2:nsim) {
#1.8. Dentro do ciclo:
#  1.8.1. Crie o objetos xsim, um vetor com valores amostrados aleatoriamente
  #de uma distribuição uniforme de 0 a 320 (o tamanho x da parcela), 
  #arredondando o valor para uma casa decimal2). Lembre-se de sortear 
  #a mesma quantidade de valores que a população de palmito observado;
  xsim <- round(runif(n.total,0,320))
#  1.8.2. Faça o mesmo que no passo anterior e guarde no objeto ysim;
  ysim <- round(runif(n.total,0,320))
#  1.8.3. Como no tópico anterior, crie uma matriz para guardar as distâncias entre cada valor xy simulados;
  dist.sim <- matrix(NA, ncol=n.total, nrow=n.total)
#  1.8.3. Crie os ciclos para o calculo das distâncias como no tópico anterior;
  for (i in 1:length(xsim)-1) {
    for (j in (i+1):length(ysim)) {
      difx2.sim=(xsim[i]-xsim[j])^2
      dify2.sim=(ysim[i]-ysim[j])^2
      dist.sim[i,j]<-sqrt(difx2.sim + dify2.sim)
      dist.sim[j,i]<-sqrt(difx2.sim + dify2.sim)
    }
  }
#  1.8.4. Guarde o valor da distância média do vizinho mais próximo dos dados simulados na posição k do vetor resultado;
  resultado[k] <- mean(apply(dist.sim, 1, min, na.rm=TRUE))
#  1.8.5. Feche o ciclo.
}
#1.9. Faça um histograma dos valores simulados e coloque uma linha vermelha vertical na posição do valor observado;
hist(resultado)
abline(v=mnn, col="red", lwd=2)
#1.10. Calcule a probabilidade de uma distribuição espacial aleatória gerar valores iguais ou mais extremos do que o valor MNN observado.
unicaudal <- sum(resultado<=resultado[1])
unicaudal
p.uni <- unicaudal/length(resultado)
p.uni
probabilidade <- p.uni*100
probabilidade
###
###Exercício 2
animais <- read.table("animais.txt", header=T, sep=";", dec=",")
animais <- animais[!is.na(animais$brain),]
animais
brain <- animais$brain
body <- animais$body
plot(brain ~body)
plot(log(brain) ~ log(body))
#2.1. Calcule a inclinação da relação log(brain) ~ log(body)
lm.animais <- lm(log(brain) ~ log(body))
summary(lm.animais)
coef(lm.animais)
inclina <- as.numeric(coef(lm.animais)[2])
inclina
#2.2. Crie um vetor para guardar o resultado de simulações;
nsim.ani <- 1000
sim.animais <- rep(NA, nsim.ani)
#2.3. Guarde o valor observado no objeto criado em 2.2;
sim.animais[1] <- inclina
#2.4. Abra um ciclo de 2 a 1000;
for (i in 2:1000) {
#2.5. Desordene o vetor brain e guarde no objeto sim_brain;
  sim_brain <- sample(brain)
#2.6. Calcule a inclinação entre o log(sim_brain) ~ log(body) e guarde no vetor resultado;
  lm.sim <- lm(log(sim_brain) ~ log(body))
  coef.sim <- as.numeric(coef(lm.sim)[2])
  sim.animais[i] <- coef.sim
#2.7. Feche o ciclo;
}
#2.8. Faça o histograma dos valores simulados e compare com o valor observado da inclinação da relação;
hist(sim.animais)
abline(v=inclina, col="red", lwd=2)
#2.9. Calcule a probabilidade da inclinação observada ter sido gerada por variáveis que são independentes;
p.lm.sim <- sum(sim.animais >= sim.animais[1])/length(sim.animais)
p.lm.sim
probabilidade.lm <- p.lm.sim*100
probabilidade.lm
