                            ##### 4.2 Cervejas #####

## Uma amostra de 30 estudantes foi indagada sobre seu tipo de cerveja preferida, com
## o seguinte resultado
cervejas <-c("chope","lata","garrafa","chope","garrafa", "garrafa","lata","lata","nenhuma",
             "lata","garrafa","garrafa", "garrafa","lata","lata","lata","garrafa","lata",
             "chope","nenhuma", "garrafa","garrafa","garrafa","chope","garrafa","garrafa",
             "chope","garrafa","lata","lata")

## Represente este resultado como um gráfico de barras e um dotplot (função dotchart)
barplot(sort(table(cervejas), decreasing = TRUE), xlab = "Tipo de cerveja preferida", ylim = c(0,15))
dotchart(table(cervejas))

## Qual tem maior razão dado/tinta?
# R/ O gráfico de pontos é mais simples e contém a mesma informação, então tem a tem
# maior razão dado/tinta

                            ##### 4.3 Caixetais #####
library(lattice)
caixeta <- read.csv(file = "caixeta.csv", header = TRUE, as.is = TRUE)
head(caixeta)
str(caixeta)

## Construa um histograma do dap dos fustes dos caixetais (parcelas)
caixeta <- data.frame(caixeta, dap = caixeta$cap/pi, stringsAsFactors = FALSE)
histogram(~ dap | as.factor(parcela), data = caixeta, xlab = "DAP")

## Construa histogramas da altura das árvores para os diferentes caixetais ('local').
histogram(~ h | as.factor(parcela), data = caixeta, xlab = "Altura")

## Há diferenças entre as estruturas (distribuição de tamanhos) dos caixetais?
# R/ Não há muita diferença na distribução do dap nem comprimento (h) das arvores nas caixetas
# todas parecen ter um cauda para à direita

                            ##### 4.4 Eucaliptos #####

e.grandis <- read.csv(file = "egrandis.csv", header = TRUE, as.is = TRUE, sep = ";")
head(e.grandis)
str(e.grandis)

## Utilize o gráfico boxplot para analisar o DAP de árvores de E. grandis em função
## das variáveis região (regiao) e rotação (rotacao)
par(mfrow = c(1,2))
boxplot(e.grandis$dap ~ e.grandis$regiao, col = "grey",
        xlab = "Região" , ylab = "E. grandis DAP")

boxplot(e.grandis$dap ~ e.grandis$rotacao, col = "grey",
        xlab = "Rotação" , ylab = "E. grandis DAP")
par(mfrow = c(1,1))

## Avalie a normalidade da altura do conjunto total de árvores com um gráfico
## quantil-quantil contra a distribuição normal
qqnorm(e.grandis$ht, ylab = "E. grandis Altura (Quanties)")
qqline(e.grandis$ht, col = "red")

                          ##### 4.5 Mais Caixetais #####

# Faz um subset com os dados para Tabebuia cassinoides
caixetaTC <- caixeta[caixeta$especie == "Tabebuia cassinoides", ]

# Cria uma nova coluna `abasfus` no data frame `caixeta` com valores de area basal de cada fuste a
# partir do valor de CAP
caixetaTC <- data.frame(caixetaTC, abasfus = ((caixetaTC$cap)^2)/(4*pi), stringsAsFactors = FALSE)

# Calcula a area basal total para cada árvore somando as areas basais dos fustes, por local e parcela
a.bas.tot <- aggregate(caixetaTC$abasfus,
                     by = list(arvore = as.factor(caixetaTC$arvore), local = as.factor(caixetaTC$local),
                               parcela = as.factor(caixetaTC$parcela)),
                     FUN = sum)

# Cria um data frame com os valores de altura para cada árvore selecionados por local e parcela
altura <- aggregate(caixetaTC$h,
                     by = list(arvore = as.factor(caixetaTC$arvore), local = as.factor(caixetaTC$local),
                               parcela = as.factor(caixetaTC$parcela)),
                     FUN = max)

# Cria um data frame juntando valores de DAP e altura para cada árvore
caixeta2 <- data.frame(a.bas.tot[, 1:3], h = altura$x, a.bas.tot = a.bas.tot$x,
                       dap = 2*sqrt(a.bas.tot$x/pi), stringsAsFactors = FALSE)
head(caixeta2)
## Analise a relação dap-altura ('dap' e 'h') em função do caixetal (local) com a função
## plot, mas somente para as árvores de caixeta (Tabebuia cassinoides)
levels(as.factor(caixeta2$local))

plot(dap ~ h, data = caixeta2[caixeta2$local == "chauas", ], pch = 16, xlab = "Altura", ylab = "DAP")

points(dap ~ h, data = caixeta2[caixeta2$local == "jureia", ], pch = 16, col = "red")

points(dap ~ h, data = caixeta2[caixeta2$local == "retiro", ], pch = 16, col = "blue")

## Para a mesma relação do item anterior, verifique linearidade com a função scatter.smooth
scatter.smooth(caixeta2$dap ~ caixeta2$h, lpars = list(lwd=2, col="red"),
               xlab = "Altura", ylab = "DAP", pch = 16)

## Utilizando o pacote lattice, analise a relação dap-altura ('dap' e 'h') em função do
## caixetal (local), mas somente para as árvores de caixeta (Tabebuia cassinoides)
xyplot(dap ~ h | local, data = caixeta2, xlab = "Altura", ylab = "DAP")