### 5.1 Editando alguns parmetros grficos

## Leia os dados Conjunto de Dados: Biomassa de rvores de Eucalyptus saligna em um objeto chamado saligna
saligna <- read.csv(file = "esaligna.csv", header = TRUE, as.is = TRUE)
head(saligna)
str(saligna)

# Use o simbolo de crculo preenchido aumentado em 40%, na cor vermelha - Legendas dos eixos
# com nomes das variveis e suas unidades da seguinte forma:
# x: Dimetro  altura do peito (cm)
# y: Altura (m)
#   Tamanho das fontes e legendas dos eixos com 50% e 70% de aumento que o padro,respectivamente
# Marcaes da escala dos eixos (ticks marks) para dentro da rea do grfico com tamanho de
# 0.3 do tamanho da linha.
# Valores do eixo y na horizontal
# Apenas as linhas referentes/ aos eixos x e y (formato L)
# Ttulo contendo: *Eucalypthus saligna* com aumento de 80%
# Salve o grfico no formato png no arquivo saligna.png no diretrio de trabalho atual.
# Mantenha o mesmo padro de formatao do exerccio anterior.
# Insira tambm uma letra para dizer qual  o grfico a e qual  o b
# (tanto faz, quem  um e quem  outro)

## Ajusta parmetros gerais do grfico

png(filename = "saligna.png")

par(cex = 1.2, tcl = 0.3, bty = "l")

## Boxplot dap por altura
plot(saligna$dap ~ saligna$ht, pch = 16, cex = 1.4, col = "red",
     xlab = "", ylab = "", axes = FALSE)
box()
axis(2, las = 2, ylim = c(0, 25))
axis(1, xlim = c(0, 25))
mtext(text = c(expression(italic("Eucalypthus saligna")), "Dimetro  altura do peito (cm)", "Altura (m)"),
      side = c(3, 1, 2), line = c(1, 2.5, 2.5), at = c(15, 16, 15),
      cex = c(1.8, 1.2, 1.2))

dev.off()

### 5.2 Dois grficos juntos

## 1. Boxplot da varivel dap em funo do fator talho
png(filename = "saligna2.png", width = 480*2, height = 480)

par(mfrow = c(1,2), cex = 1.2, tcl = 0.3, bty = "l")

boxplot(saligna$dap ~ saligna$talhao, xlab = "", ylab = "", axes = FALSE)
box()
axis(2, las = 2, ylim = c(0, 25))
axis(1, xlim = c(0, 25))
mtext(text = c("Talho", "DAP (cm)", expression(paste(bold("A")))),
      side = c(1, 2, 3), line = c(2.5, 2.5, 2), at = c(3.5, 15, 0),
      cex = c(1.2, 1.2, 1.5))

## 2. Grfico da mdia e desvio-padro do dap, para cada talho 

# Calcula la mdia y la desviacin estandar del DAP para cada uno de los talhoes
medias <- aggregate(saligna$dap ~ saligna$talhao, FUN = mean)
desv <- aggregate(saligna$dap ~ saligna$talhao, FUN = sd)
saligna2 <- data.frame(talhao = levels(as.factor(saligna$talhao)), mediaDAP = medias$`saligna$dap`,
                       desv = desv$`saligna$dap`, stringsAsFactors = FALSE)

# Faz o boxplot
mp <- barplot(height = saligna2$mediaDAP, names.arg = saligna2$talhao, ylim = c(0, 25),
              xlab = "", ylab = "", border = NA, col = "white", axes = FALSE)
box()
axis(2, las = 2, ylim = c(0, 25))
abline(h = 0)
mtext(text = c("Talho", "Mdia do DAP (cm)", expression(paste(bold("B")))),
      side = c(1, 2, 3), line = c(2.5, 2.8, 2), at = c(3.5, 13, 0),
      cex = c(1.2, 1.2, 1.5))

# Adiciona pontos com os valores das mdias 
points(x = mp, y = saligna2$mediaDAP, pch = 16, col = "red", cex = 1.4)

# Desenha as linhas do desvio-padro
upper <- saligna2$mediaDAP + saligna2$desv
lower <- saligna2$mediaDAP - saligna2$desv

segments(mp, lower, mp, upper, lwd = 1.8)
segments(mp - 0.1, lower, mp + 0.1, lower, lwd=1.8)
segments(mp - 0.1, upper, mp + 0.1, upper, lwd=1.8)

dev.off()

### 5.3 Adivinhando o cdigo
dados5.3 <- read.csv(file = "dados5(3).csv", header = TRUE, as.is = TRUE)
dados5.3
str(dados5.3)

## Parmetros gerais do grfico
png(filename = "adivinhando.png", width = 480*1.85, height = 480)

par(tcl = 0.4, bty = "l", family = "serif", cex.axis = 1.2, mfrow = c(1,2))

## 1. Grfico de tringulos
plot(x = dados5.3$x1, y = dados5.3$y1, xlim = c(0.5, 2.2), ylim = c(0, 3),
     pch = 17, cex = 1.5, xlab = "", ylab = "")
segments(x0 = 0.5, y0 = 2.25, x1 = 2.18, y1 = 1, lwd = 3)
mtext(text = c("Euclidean distances", "Log(Patch size)(ha)"), 
      side = c(2, 1), at = c(1.5, 1.3), line = 2.5, cex = c(1.7, 1.3))
text(x = 2.18, y= 3, labels = "a", cex = 2)

## 2. Boxplot
boxplot(dados5.3$x2 ~ dados5.3$y2, ylim = c(0,3), axes = FALSE, outline = FALSE)
axis(1, labels = FALSE, lwd = 0, lwd.ticks = 1, tcl = 0.5)
axis(2, lwd = 0, lwd.ticks = 1, tcl = 0.5)
box()
mtext(text = c("Small", "Medium\nEdge", "Medium\nInterior", "Large\nEdge",
               "Large\nInterior", "Control"), side = 1, at = c(1, 2, 3, 4, 5, 6),
      line = c(1.2, 2, 2, 2, 2, 1.2), cex = 1.2)
text(x = 6.5, y= 3, labels = "b", cex = 2)
text(x = c(1,2,3,4,5), y= 3, labels = c("*", "*", "**", "*", "***"), cex = 1.8)

dev.off()
