## 1. Vamos retomar a regresso da massa do crebro em funo da massa corporal de alguns animais
library(MASS)
data(Animals)
str(Animals)

## 2. Regreso massa crebro em funo da massa do corpo
anim.m2 <- lm(log(brain) ~ log(body), data = Animals, 
              subset =! (log(Animals$body) > 8 & log(Animals$brain) < 6))

# Dando uma olhada aos resultados
summary(anim.m2)
anova(anim.m2)

par(mfrow = c(2,2))
plot(anim.m2)
par(mfrow = c(1,1))

## 3. Agora ajuste este modelo
anim.m0 <- lm(log(brain) ~ 1, data = Animals, 
              subset =! (log(Animals$body) > 8 & log(Animals$brain) < 6))

# Dando uma olhada aos resultados
summary(anim.m0)
anova(anim.m0)

par(mfrow = c(2,2))
plot(anim.m0)
par(mfrow = c(1,1))


## 4. Comparando modelos
plot(log(brain) ~ log(body), data = Animals, 
     subset =! (log(Animals$body) > 8 & log(Animals$brain) < 6))
abline(anim.m2, col = "red")
abline(anim.m0, col = "blue") # Modelo nulo
text(x = c(-1.5, -0.7), y = 0, labels = c("m =", round(anim.m2$coefficients[2], 2)))
text(x = -3.5, y = 4.9, labels = "m = 0")

anova(anim.m0, anim.m2)

#### Perguntas

## 1. Qual a relao do comando 'anova' acima com:
anova(anim.m2)

# R/ O comando acima  a tabela da partio de varianas dos modelos comparados
# (o modelo nulo e o modelo em que a massa do crebro depende da massa do corpo). Entanto
# que o segundo comando constroi a tabela da partio de varianas do modelo em que a massa
# do crebro depende da massa do corpo; esse ltimo sumario apresenta a proporo
# de variana explicada pela massa do corpo, alm da variana que o modelo no
# explicou residuais). Por fim, o comando acima contem tudos os resultados do comando
# abaixo, por conta disso o valor F  igual, alm soma de desvios cuadraticos (SRR) e
# os residuais.

## 2. Qual a relao entre os valores obtidos por estes comandos:
summary(anim.m0)
mean(log(Animals$brain[!(log(Animals$body) > 8 & log(Animals$brain) < 6)]))
sd(log(Animals$brain[!(log(Animals$body) > 8 & log(Animals$brain) < 6)]))

# R/ A mdia y o desvio padro apresentados por os comandos acima so iguais, porque
# anim.m0  o modelo nulo no qual a melhor reta com pendente 0 que descreve a variao
# dos dados  a mdia da variable resposta,  por isso que coincide com o valor do
# intercepto apresentado na funo summary. O erro padro  equivalente ao desvio
# padro total dos dados, isto  a distana entre cada dado e a mdia total.

## Um comando mais curto para ajustar o modelo deste exerccio, e que ajuda a interpret-lo
anim.m0 <- update(anim.m2, .~. -log(body))
