                  ####### 1. Distribui??o dos palmitos #######

# A pergunta ?: Os palmitos est?o distribu?dos aleatoriamente na floresta?

## 1. Baixe o arquivo palmadulto.txt e leia os dados no R em um objeto chamado eutad, n?o esque?a
# de conferir se o objeto de dados foi lido corretamente
eutad <- read.csv(file = "palmadulto.csv", sep = "\t", as.is = TRUE)

## 2. Crie o objeto para guardar as dist?ncias entre cada indiv?duo
dist <- matrix(NA, ncol = 102, nrow = 102)
dist[1:5, 1:5]

## 3. Calcule a dist?ncia observada entre cada indiv?duo e guarde o resultados em dist
for(i in 1:101)
{
  for(j in (i+1):102)
  {
    difx2 <- (eutad$gx[i] - eutad$gx[j])^2
    dify2 <- (eutad$gy[i] - eutad$gy[j])^2
    dist[i,j]<- sqrt(difx2 + dify2)
    dist[j,i]<- sqrt(difx2 + dify2)
  }
  
}

## 4. Verifique o objeto dist e calcule o par?metro chamado de dist?ncia m?dia do vizinho mais
# pr?ximo (MNN)
nn <- apply(X = dist, MARGIN = 1, FUN = min, na.rm = TRUE)

mnn <- mean(nn) # dist?ncia m?dia do vizinho mais pr?ximo

## 5. Simulando

# 1.5. Crie um vetor resultado, com 1000 NA's, para guardar os valores de cada simula??o
# 1.6. Guarde o valor observado na primeira posi??o de resultado
# 1.7. Crie um ciclo com contador (k) que vai de 2 a 1000
# 1.8. Crie o objetos xsim, ysim, gere o ciclo e Guarde o valor da distância média do vizinho
# mais próximo
  
nsim = 1000
resulta <- rep(NA, nsim)
resulta[1] <- mnn

for(k in 2:nsim)
{
  xsim <- round(runif(n = 102, min = 0, max = 320), digits = 2)
  ysim <- round(runif(n = 102, min = 0, max = 320), digits = 2)
  dist <- matrix(NA, ncol = 102, nrow = 102)
    for(i in 1:101)
    {
      for(j in (i+1):102)
      {
        difx2 <- (xsim[i] - xsim[j])^2
        dify2 <- (ysim[i] - ysim[j])^2
        dist[i,j]<- sqrt(difx2 + dify2)
        dist[j,i]<- sqrt(difx2 + dify2)
      }
    
    }

  resulta[k] <- mean(apply(X = dist, MARGIN = 1, FUN = min, na.rm = TRUE)) 

}

  # 1.9. Fa?a um histograma dos valores simulados e coloque uma linha vermelha vertical na
  # posi??o do valor observado
hist(resulta, main = "", xlab = "Distância média do vizinho mais próximo",
     col = "grey")
abline(v = resulta[1], col = "red")

  # 1.10. Calcule a probabilidade de uma distribui??o espacial aleat?ria gerar valores iguais
  # ou mais extremos do que o valor MNN observado
  
  # Primeiro vamos localizar a m?dia do vetor `resulta` em 0
resulta <- resulta - mean(resulta)

hist(resulta, main = "", xlab = "Distância média padronizada do vizinho mais próximo",
     col = "grey")
abline(v = resulta[1], col = "red")
abline(v = resulta[1]*(-1), col = "red")

  # Agora vamos somar a propabilidade nas duas caudas
pdist <- (sum(resulta >= resulta[1]*(-1) | resulta <= resulta[1])) / nsim
pdist


    ####### 2. Simulando o teste de uma regressão linear #######

## Utilizando os dados de massa corpórea e do cérebro de alguns vertebrados Conjunto de
# Dados: Massa do Corpo e do Cérebro de Vertebrados
massa <- read.csv(file = "arquivo.csv", sep = ";", as.is = TRUE)
str(massa)
summary(massa)
length(massa$body)

## Removendo NAs
massa <- massa[- c(which(is.na(massa$brain))), ]
massa
length(massa$body)

## 1. Calcule a inclinação da relação log(brain) ~ log(body)
massa$body <- log(massa$body)
massa$brain <- log(massa$brain)

Xx <- (massa$body) - mean(massa$body)
Yy <- (massa$brain) - mean(massa$brain)
SSY <- sum(((massa$body) - mean(massa$body))^2)

beta <- (sum(Xx * Yy)) / SSY
beta

# 2. Crie um vetor para guardar o resultado de 1000 simulações do valor da inclinação entre
# o log(sim_brain) ~ log(body) 
resultado <- rep(x = NA, times = 1000)
resultado[1] <- beta

nsim = 1000
for(i in 2:nsim)
{
  sim_brain <- sample(massa$brain)
  
  Xx <- (massa$body) - mean(massa$body)
  Yy <- (sim_brain) - mean(sim_brain)
  SSX <- sum(((sim_brain) - mean(sim_brain))^2)
  
  resultado[i] <- beta <- (sum(Xx * Yy)) / SSX
}

# 8. Faça o histograma dos valores simulados e compare com o valor observado da inclinação
# da relação
hist(resultado, main = "", xlab = "Média da massa do cérebro (log)", col = "grey")
abline(v = resultado[1], col = "red", lwd = 2)

# 9. Calcule a probabilidade da inclinação observada ter sido gerada por variáveis que são
# independentes

# Primeiro vamos localizar a m?dia do vetor `resulta` em 0
resultado <- resultado - mean(resultado)

hist(resultado, main = "", xlab = "Média padronizada da massa do cérebro (log)",
     col = "grey")
abline(v = resultado[1], col = "red")
abline(v = resultado[1]*(-1), col = "red")

# Agora vamos somar a propabilidade nas duas caudas
pvet <- (sum(resultado >= resultado[1] | resultado <= resultado[1]*(-1))) / nsim
pvet